XSIS(1CAD)

NAME
xsis - graphical interface to sis based on Athena widget set.

SYNOPSYS
xsis [-sis pathname] [-debug] [X Toolkit options...]

DESCRIPTION
xsis is a graphical front-end for sis, the Berkeley Sequential Interactive System. The initial goal of this program is to provide support for the plot command from earlier versions of sis in a manner which is portable under the MIT distribution of X11R4. xsis is based on the Athena widget set and the X Toolkit, and works with sis versions 1.1 and later.

xsis runs a copy of sis as a child process. This means that any ordinary command-line version of sis can be run under xsis without recompiling anything. To locate a copy of sis to run, xsis first searches the directories specified in the $PATH environment variable. If there is no executable named ``sis'' there, it tries the directory that xsis is located in.

The widget hierarchy used by xsis is documented below so you can customize it using X resources. Notice that the names of some top level windows depend on what data has been displayed in them (e.g. the network plot windows). The instance name is shown first followed by the class name in parenthesis. Although X11 refers to a top level window as a shell, we will loosely refer to them as windows to avoid confusion with command-line shells such as csh. xsis uses multiple top level windows which are described below. The sis graphics package file graphics.doc describes the interface conventions between xsis and sis, and outlines how to add new graphics features.

OPTIONS
xsis accepts the following options:

-sis pathname
    Run specified version of sis instead of searching in the xsis and $PATH directories.

-debug
    Produce xsis debug output which is both verbose and invaluable when there are problems.

-bg color
    Set the background color for all windows.

-bd color
    Set the border color for all windows.

-bw n
    Set the border width to n pixels for all windows.

-display displayname
    Use the specified display for all windows.

-fg color
    Set the foreground color for all windows.

-fn fontname
    Use specified font in all windows. Since xsis has multiple windows, it is usually more convenient to set the font for each window separately using .Xdefaults as described below.

-geometry value
    Set the initial geometry of the command window.

-name value
    Use an alternate name for looking up resources in the .Xdefaults file.

xsis also supports all other standard X Toolkit options, such as -font and -foreground.

SIS COMMANDS
When sis is run using the xsis interface, you can use the following graphics commands.

plot_blif [-n <name>] [-g <geom>] [-k] [-i] [-r]
    Create a new plot window and display the current network.
    -n <name> Specifies the plot window name instead of using the network name.
    -g <geom> Give the initial geometry of the window, using the standard X11 format: WxH+X+Y.
    -r Replace the drawing in the last window created with the same plot name.
    -k Kill the last plot with the same plot name.
    -i Label the plot with the internal network names used by sis.

_speed_plot [-n name] [-c] [-g] [-h] [-t n.n] [-w n.n] [-d n]
    Without -h or -c, this adds buttons to the plot window to select either the critical path or cutset.
    -n name Specifies the plot window name instead of using the network name.
    -c Highlight the minimum weight cutset.
    -h Highlight nodes on a critical path.
    -g Label the nodes with their gate names (after technology mapping).
    -t n.n Critical threshold.
    -w n.n Relative weight of area.
    -d n Distance for collapsing.

help [-g <geom>] topic
    Display help for the topic in a separate help window. Only one help window is ever open, so repeated help commands just change the topic.

COMMAND WINDOW
This is the main window where you enter sis commands and view sis text output.

        xsis (XSis)
                paned (Paned)
                        box (Box)
                                quit (Command)
                                clear (Command)
                                print (Command)
                                version (Label)
                        cmdline (Text)
                        textout (Text)

The command text widget supports several standard control characters: ^D for EOF, ^U for kill, ^C for interrupt, and ^D/ESC for file completion.

NETWORK PLOT WINDOW
This window is created for each separate network plot you make. By default it shows the network structure as described by the write_blif command. You can display the internal sis network structure by using plot_blif -i. For default actions, clicking the left button on a node highlights the node and its fanins and fanouts. Clicking the middle button issues a print command on the node in the command window.

        xsis (XSis)
                network-name (TopLevelShell)
                        blifPane (Paned)
                                box (Box)
                                        close (Command)
				label (Label)
                                netPlot (NetPlot)

The NetPlot widget supports the following resources:

Name | Type | Default | Description
background | Pixel | white | Background color of plot.
foreground1 | Pixel | black | Color of internal nodes.
foreground2 | Pixel | black | Color of PI nodes.
foreground3 | Pixel | black | Color of PO nodes.
foreground4 | Pixel | black | Color of graph edges.
hilight | Pixel | black | Highlighting color for plot.
font | FontStruct | ? | Font for all text in the plot.

There are two defined actions:

SelectMe ()
    Highlight a node, its fanins and fanouts.

NodeCmd ([hit],[miss])
    Execute a sis command on a node. The first %s in the hit parameter is replaced by the node which was hit before the command is sent to sis. The miss command is executed if no node was hit by the event.

HELP WINDOW
The help window is a separate window for displaying sis on-line help. Only one help window is ever created and each new topic you select is displayed in this window.

        xsis help (TopLevelShell)
                paned1 (Paned)
                        box (Box)
                                close (Command)
                                label (Label)
                        paned2 (Paned)
                                topicList (Viewport)
                                        list (List)
                                helpText (Text)

X DEFAULTS
Using the above window hierarchies, you can customize xsis with resources specified in the .Xdefaults file. To change all pushbuttons to red:

        XSis*Command*foreground: red

To change only the close pushbuttons to red:

        XSis*close*foreground: red

To change the color of PO nodes in all plots to orange:

        XSis*netPlot.foreground3: orange

The resources which most closely match the network plot to the old plot command in sis:

XSis*netPlot.background: | white
XSis*netPlot.foreground1: | blue
XSis*netPlot.foreground2: | red
XSis*netPlot.foreground3: | green
XSis*netPlot.foreground4: | black
XSis*netPlot.font: | courier10

For a list of other resources which can be changed, see the resource list at the beginning of file xsis.c, and the MIT Athena Widgets documentation.

FILES
/projects/sis/sis/common/src/xsis/ | - source for xsis
~/.Xdefaults | - resources to customize xsis

SEE ALSO
sis(1CAD)

DIAGNOSTICS
If you use xsis with a version of sis which does not support graphics, you will get a message similar to:

	$ xsis -sis sis1.0
	sis1.0: unknown option X
	usage: sis1.0 [-sx] [-c cmd] [-f script] ...

If no directory in your path contains an executable named sis:

	$ xsis
	xsis: could not find "sis" in your path.

BUGS
Typing ^Z in the command window does not interrupt or suspend the program, and suspending xsis from the shell only suspends it and not the associated sis child process.

The Athena text widget used for the command window display does not support cursor positioning, so using the sis shell escape (!) with commands such as more or vi does not work very well.

Since graphics commands such as plot_blif must be supported by the underlying version of sis, they really should be documented there somehow.

AUTHORS
Paul Stephan
Copyright 1991 by the Regents of the Univerity of California.